#!/usr/bin/python
# -*- encoding: utf-8 -*-

"""Configuration d'un bot IRC (squelette de base vide)"""

debug_stdout = True

### La config irc-related
irc_password = "HiddenInPlainSight"
irc_pseudo = "BBC"
ircname = "Come to #DW"
#: Liste des chans à rejoindre
chanlist = ["#bot"] # #DW
#: Liste des chans que le bot ne quitte pas, même sur demande d'un leave de la part d'un OP
stay_channels = ["#bot"] # #DW
#: Liste des chans sur lesquels le bot ne parle pas
quiet_channels = []

### Les logs
#: fichier de log (``%s`` est remplacé par le nom du serveur)
logfile_template = "bbc.%s.log"

### Les ops
#: Liste des OVEROPs (meilleurs que les OP ^^)
overops = ["[20-100]"]
#: Liste des OPs (la liste des :py:data:`overops` y est ajoutée)
ops = []

# config UTF8-fail
utf8_fail_answers = [u"Have you tried to reverse the polarity of the encoding flow?"]
#: Le bot râle-t-il en cas de non-utf8 ?
utf8_trigger = True

### config "tu m'traites ?"
#: Liste des insultes reconnues par le bot
insultes = [u"conna(rd|sse)", u"pute", u"con(|ne)", u"enf(oiré|lure)",
u"sal(op(|e(|rie)|ard)|aud)", u"p(e|')tite bite", u"imbécile", u"idiot", u"stupid(|e)", u"débile", u"crétin",
u"pétasse", u"enculé", u"chagasse", u"cagole", u"abruti", u"ahuri", u"analphabète", u"andouille",
u"atardé", u"avorton", u"bachibouzouk", u"(balais|brosse) (de|à) chiotte(|s)",
u"batard", u"blaireau", u"bouffon", u"branque", u"bouseux", u"branleur", u"catin", u"chacal",
u"charogne", u"chiant(|e)", u"chieur", u"cochon", u"coprophage", u"couillon", u"crapule", u"crevard",
u"cruche", u"cuistre", u"ducon", u"décérébré",
u"emmerdeur", u"feignasse", u"fainéant", u"fourbe", u"freluquet", u"frigide",
u"garce", u"glandu", u"gogol", u"goujat", u"gourdasse", u"gredin", u"gringalet", u"grognasse",
u"naze", u"truie", u"iconoclaste",
u"peigne(-|)cul", u"ignare", u"illétré", u"lèche(|-)cul", u"malotru", u"motherfucker", u"nabot", u"nigaud",
u"nul", u"escroc", u"pouffiasse", u"pourriture", u"raclure", u"relou", u"sagouin", u"putain",
u"péripatéticienne"]
#: Liste des réponses possibles à une insulte
insultes_answers = [
u"Ceci est une réponse à une insulte."]

### config "tais-toi"
#: Liste des pattern qui vont faire taire le bot
tag_triggers = [u"t(|a)g", u"ta gueule", u"la ferme", u"ferme( |-)la", u"tais-toi", u"chut", u"tu fais trop de bruit", u"tu parles trop"]
#: Liste des actions effectuées en réponses à un :py:data:`tag_triggers` si
#: l'utilisateur n'est pas OP
tag_actions = [u"effectue une action en réponse à un \"tais-toi\"."]
#: Liste des réponses adressée à un utilisateur non-OP
#: suite à un :py:data:`tag_triggers`
tag_answers = [
u"Ceci est une réponse à un 'tais-toi' à quelqu'un qui n'en a pas le droit."]

### config ping
#: Liste des pings
tesla_triggers = [u"t('|u )es là \?", u"\?", u"plop \?", u"plouf \?"]
#: Liste des pongs
tesla_answers = [
u"Ceci est une réponse à 't'es là ?'."
]
#: Liste des actions pong
tesla_actions = [u"effectue une action en réponse à un \"t'es là ?\"."]

### config en cas de non-insulte
#: Liste des compliments
compliment_triggers = [u"gentil", u"cool", u"sympa", u"efficace"]
#: Liste des réponses à un compliment
compliment_answers = [
u"Ceci est une réponse à une non-insulte."
]

### config merci
#: Liste des mercis
merci_triggers = [u"merci", u"remercie", u"thx", u"thank(|s)"]
#: Liste des réponses à un remerciement
merci_answers = [u"Ceci est une réponse à un remerciement."]

# config "ta mère" 
tamere_triggers = [u"ta mère"]
tamere_answers = [u"Ceci est une réponse à un \"ta mère\"."]

# config pour les actions désagréables
bad_action_triggers = [u"(frappe|cogne|tape)(| sur)", u"(démolit|dégomme|fouette|agresse|tabasse)",
u"(vomit|pisse|chie|crache) sur", u"slap(|s)"]
bad_action_answers = [
u"Ceci est une réponse en cas d'action désagréable. (Elle a été perpetrée par {})"
]
bad_action_actions = [u"effectue une action en réponse à une action désagréable."]

# config pour les actions agréables
good_action_triggers = [u"fait (:?des bisous|un c(?:â|a)lin|des c(?:â|a)lins) à", u"embrasse", u"c(?:â|a)line", u"caresse"]
good_action_answers = [u"Ceci est une réponse à une action agréable. (Prodiguée par {})"]
good_action_actions = [u"effectue une action en réponse à une action agréable."]

# config bonjour/bonsoir/que fais-tu encore debout à cette heure, gros sale !
bonjour_triggers = [u"(s|)(a|'|)lu(t|)", u"hello", u"pl(o|i)p", u"pr(ou|ü)t", u"bonjour", u"bonsoir", u"coucou"]
bonjour_answers = [u"Ceci est un message bonjour. (En réponse à {})"]
bonsoir_answers = [u"Ceci est un message bonsoir. (En réponse à {})"]
night_answers = [u"Ceci est un message envoyé à {} si il dit bonjour en pleine nuit."]
daytime = [7, 18] # c'est quoi le "jour" ?
nighttime = [3, 6] # c'est quoi la "nuit" ?

# config dodo
bonne_nuit_triggers = [u"bonne nuit", u"'?nite", u"'?nuit", u"'?night", u"good night", u"'?nenuit"]
bonne_nuit_answers = [u"Ceci est un message de souhait de bonne nuit. (En réponse à {})"]

# config quelqu'un s'est défoulé sur le bot
kick_answers = [u"Ceci est un message suite à /kick (Perpetré par {})"]
kick_actions = [u"effectue une action suite à un /kick."]

# config on m'a demandé de mourir/partir
quit_messages = [u"Geronimo!", u"Allons-y!", u"I don't wanna go!"]
leave_messages = quit_messages

quit_fail_messages = [u"Check your records again."]
leave_fail_messages = quit_fail_messages

# config d'aide
helpdico = {"help" : ["""HELP <commande>
 Affiche de l'aide sur la commande""", None, None],
 "join" : [None, """JOIN <channel>
 Me fait rejoindre le channel""", None],
 "leave" : [None, """LEAVE <channel>
 Me fait quitter le channel (sauf s'il est dans ma stay_list).""", None],
 "quiet" : [None, """QUIET <channel>
 Me rend silencieux sur le channel.""", None],
 "noquiet" : [None, """NOQUIET <channel>
 Me rend la parole sur le channel.""", None],
 "say" : [None, None, """SAY <channel> <message>
 Me fait parler sur le channel."""],
 "do" : [None, None, """DO <channel> <action>
 Me fait faitre une action (/me) sur le channel."""],
 "stay" : [None, None, """STAY <channel>
 Ajoute le channel à ma stay_list."""],
 "nostay" : [None, None, """NOSTAY <channel>
 Retire le channel de ma stay_list."""],
 "ops" : [None, None, """OPS
 Affiche la liste des ops."""],
 "overops" : [None, None, """OVEROPS
 Affiche la liste des overops."""],
 "kick" : [None, None, """KICK <channel> <pseudo> [<raison>]
 Kicke <pseudo> du channel (Il faut bien entendu que j'y sois op)."""],
 "die" : [None, None, """DIE
 Me déconnecte du serveur IRC."""],
 "op" : [None, None, """OP <channel> [<pseudo>]
 Donne le mode +o à <pseudo> sur <channel>. À défaut de pseudo, oppe l'interlocuteur."""],
 "deop" : [None, None, """DEOP <channel> [<pseudo>]
 Enlève le mode +o à <pseudo> sur <channel>. À défaut de pseudo, déoppe l'interlocuteur."""],
}
